; GetExpTable demo by Vortex

.386
.model flat,stdcall
option casemap:none

include		\GeneSys\include\windows.inc
include		\GeneSys\include\kernel32.inc
include		\GeneSys\include\user32.inc
include		\GeneSys\include\GeneSys.inc

GetExpTable	PROTO hModule:DWORD,pExpTable:DWORD

EXPORT_TABLE	STRUCT
    NumbOfNames			DWORD ? ; number of exported functions
    AddrOfNames			DWORD ? ; address pointing to an array of RVAs of function names
    AddrOfEntryPoints	DWORD ? ; address pointing to an array of RVAs of function etry points
EXPORT_TABLE    ENDS

includelib	\GeneSys\lib\kernel32.lib
includelib	\GeneSys\lib\user32.lib
includelib	\GeneSys\GSLib\GeneSys.lib

.data
DLLmodule	db 'user32.dll',0
format1		db 'Function = %s , Entry point = %X',13,10,0
message1	db 'The first ten functions from user32.dll with the entry points',13,10,13,10,0

.data?
buffer		EXPORT_TABLE <?>
buffer2		db 256 dup(?)

.code

start:

	invoke	ConsoleOut,ADDR message1
	invoke	LoadLibrary,ADDR DLLmodule
	mov		ebx,eax                         
	invoke	GetExpTable,eax,ADDR buffer

    mov		esi,buffer.AddrOfNames
    mov		edi,buffer.AddrOfEntryPoints

    mov		ecx,10
@@:
    push	ecx
    mov		eax,DWORD PTR [esi]	; Get the RVA of function name
    add		eax,ebx				; Add handle to DLL to get the virtual address
    mov		edx,DWORD PTR [edi]	; Get the RVA of function entry point
    add		edx,ebx				; Add handle to DLL to get the virtual address

    invoke	wsprintf,ADDR buffer2,ADDR format1,eax,edx
    invoke	ConsoleOut,ADDR buffer2
    add		esi,4
    add		edi,4 
    pop		ecx
    dec		ecx
    jnz		@b
    invoke	FreeLibrary,ebx
    invoke	ExitProcess,0

END	start